/*+
|                                               |
|     Trigger: DTULTATU_SITUCAND                |  
|     Tabela : SITUCAND                         |
|                                               |
|     Criao:                                  |
|     19/07/2007 - Luiz Passos                  |
|                                               |
+*/

create or replace TRIGGER DTULTATU_SITUCAND
BEFORE INSERT OR UPDATE OR DELETE
ON SITUCAND FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSITCAND := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDSITUCAND,0) <> NVL(:NEW.CDSITUCAND,0)) OR
           (NVL(:OLD.NMSITUCAND,0) <> NVL(:NEW.NMSITUCAND,0)) THEN
         :NEW.DTULTATUSITCAND := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SITUCAND'  , '', 'CDSITUCAND='||:OLD.CDSITUCAND||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SITUCAND MODIFY DTULTATUSITCAND DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_SITUCAND','5.01.008'); END;
/

