/* Sistemas Integrados TECNISA

Nome: 0000_FINTMP_ATUALIZA_FINANCEIRO.SQL

Descrio:
Script para atualizao de dados dos sistemas financeiro [PAG - REC - BCO]

Criao:
27/06/02 - Jenilson Ferreira

Chamada para execuo:
 @C:\WIN_V2\SQL\END_CONV\SQLSERVER\0000_FINTMP_ATUALIZA_FINANCEIRO.SQL

*/


/* Corrige o fluxo de caixa dos ajustes dos boletos baixados */
DECLARE @V_AJBOLPAG_CDEMPRESA    VARCHAR(02);
DECLARE @V_AJBOLPAG_CDFILIAL     VARCHAR(04);
DECLARE @V_AJBOLPAG_CDCLASSFINA  VARCHAR(06);
DECLARE @V_AJBOLPAG_DTMOVFLUXO   DATETIME;
DECLARE @V_AJBOLPAG_IDMOVFLUXO   VARCHAR(01);
DECLARE @V_AJBOLPAG_CDFILIBOLPAG VARCHAR(04);
DECLARE @V_AJBOLPAG_NRLANBOLPAG  VARCHAR(10);
DECLARE @V_AJBOLPAG_CDAJUCTPAG   VARCHAR(04);
DECLARE @V_AJBOLPAG_IDAJUCTPAG   VARCHAR(01);
DECLARE @V_AJBOLPAG_DTBAIXAPAG   DATETIME;
DECLARE @V_AJBOLPAG_IDSTATUSBPAG VARCHAR(1);
DECLARE @V_AJBOLPAG_VRTOTAL      FLOAT;
DECLARE @V_VRFLUXOCAIXA          FLOAT;
DECLARE @V_IDSTATUS              VARCHAR(1);
BEGIN
   DECLARE C_AJBOLPAG CURSOR FOR
   SELECT
      AJ.CDEMPRESA,    AJ.CDFILIAL,
      AJ.CDCLASSFINA,  AJ.DTMOVFLUXO,
      AJ.IDMOVFLUXO,   AJ.CDFILIBOLPAG,
      AJ.NRLANBOLPAG,  AJ.CDAJUCTPAG,
      AJ.VRFXAJBOLPAG, TJ.IDAJUCTPAG,
      BP.DTBAIXAPAG,   BP.IDSTATUSBPAG
   FROM
      BAIXAPAGA   BP, BOLETPAGAR  BO,
      MOVFXAJBOLP AJ, TIPOAJPAGAR TJ
   WHERE
      BP.CDFILIAL     = BO.CDFILIBAIPAG AND
      BP.NRBAIXAPAG   = BO.NRBAIXAPAG   AND
      BO.CDFILIAL     = AJ.CDFILIBOLPAG AND
      BO.NRLANBOLPAG  = AJ.NRLANBOLPAG  AND
      AJ.CDAJUCTPAG   = TJ.CDAJUCTPAG;
   OPEN C_AJBOLPAG;
   FETCH NEXT FROM C_AJBOLPAG INTO @V_AJBOLPAG_CDEMPRESA,   @V_AJBOLPAG_CDFILIAL,
                                   @V_AJBOLPAG_CDCLASSFINA, @V_AJBOLPAG_DTMOVFLUXO,
                                   @V_AJBOLPAG_IDMOVFLUXO,  @V_AJBOLPAG_CDFILIBOLPAG,
                                   @V_AJBOLPAG_NRLANBOLPAG, @V_AJBOLPAG_CDAJUCTPAG,
                                   @V_AJBOLPAG_VRTOTAL,     @V_AJBOLPAG_IDAJUCTPAG,
                                   @V_AJBOLPAG_DTBAIXAPAG,  @V_AJBOLPAG_IDSTATUSBPAG;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF ((@V_AJBOLPAG_DTMOVFLUXO <>  @V_AJBOLPAG_DTBAIXAPAG) OR
         ((@V_AJBOLPAG_IDMOVFLUXO = 'E') AND (@V_AJBOLPAG_IDSTATUSBPAG = 'E'))) BEGIN

         IF (@V_AJBOLPAG_IDSTATUSBPAG = 'E') BEGIN
            SET @V_IDSTATUS = 'R';
         END
         ELSE BEGIN
            SET @V_IDSTATUS = 'E';
         END;

         /* - ATUALIZA O FLUXO DE CAIXA -------------------------- */
         SET @V_VRFLUXOCAIXA = @V_AJBOLPAG_VRTOTAL * -1;
         IF (@V_AJBOLPAG_IDAJUCTPAG = 'A') BEGIN
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJBOLPAG_CDEMPRESA,
                                         @V_AJBOLPAG_CDFILIAL,
                                         @V_AJBOLPAG_DTMOVFLUXO,
                                         @V_AJBOLPAG_IDMOVFLUXO,
                                         @V_AJBOLPAG_CDCLASSFINA,
                                         0,
                                         @V_VRFLUXOCAIXA;

            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJBOLPAG_CDEMPRESA,
                                         @V_AJBOLPAG_CDFILIAL,
                                         @V_AJBOLPAG_DTBAIXAPAG,
                                         'R',
                                         @V_AJBOLPAG_CDCLASSFINA,
                                         0,
                                         @V_AJBOLPAG_VRTOTAL;
         END
         ELSE BEGIN
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJBOLPAG_CDEMPRESA,
                                         @V_AJBOLPAG_CDFILIAL,
                                         @V_AJBOLPAG_DTMOVFLUXO,
                                         @V_AJBOLPAG_IDMOVFLUXO,
                                         @V_AJBOLPAG_CDCLASSFINA,
                                         0,
                                         @V_AJBOLPAG_VRTOTAL;

            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJBOLPAG_CDEMPRESA,
                                         @V_AJBOLPAG_CDFILIAL,
                                         @V_AJBOLPAG_DTBAIXAPAG,
                                         'R',
                                         @V_AJBOLPAG_CDCLASSFINA,
                                         0,
                                         @V_VRFLUXOCAIXA;
         END;

         UPDATE MOVFXAJBOLP
         SET
           IDMOVFLUXO = 'R',
           DTMOVFLUXO = @V_AJBOLPAG_DTBAIXAPAG
         WHERE
           CDEMPRESA    = @V_AJBOLPAG_CDEMPRESA    AND
           CDFILIAL     = @V_AJBOLPAG_CDFILIAL     AND
           CDCLASSFINA  = @V_AJBOLPAG_CDCLASSFINA  AND
           DTMOVFLUXO   = @V_AJBOLPAG_DTMOVFLUXO   AND
           IDMOVFLUXO   = @V_AJBOLPAG_IDMOVFLUXO   AND
           CDFILIBOLPAG = @V_AJBOLPAG_CDFILIBOLPAG AND
           NRLANBOLPAG  = @V_AJBOLPAG_NRLANBOLPAG  AND
           CDAJUCTPAG   = @V_AJBOLPAG_CDAJUCTPAG;
      END;
      FETCH NEXT FROM C_AJBOLPAG INTO @V_AJBOLPAG_CDEMPRESA,   @V_AJBOLPAG_CDFILIAL,
                                      @V_AJBOLPAG_CDCLASSFINA, @V_AJBOLPAG_DTMOVFLUXO,
                                      @V_AJBOLPAG_IDMOVFLUXO,  @V_AJBOLPAG_CDFILIBOLPAG,
                                      @V_AJBOLPAG_NRLANBOLPAG, @V_AJBOLPAG_CDAJUCTPAG,
                                      @V_AJBOLPAG_VRTOTAL,     @V_AJBOLPAG_IDAJUCTPAG,
                                      @V_AJBOLPAG_DTBAIXAPAG,  @V_AJBOLPAG_IDSTATUSBPAG;
   END;
   CLOSE C_AJBOLPAG;
   DEALLOCATE C_AJBOLPAG;
END;
GO

/* Atualiza o Status do fluxo de Caixa 'P' Previsto */
DECLARE @V_VRFLUXO FLOAT;
DECLARE @V_QTFLUXO NUMERIC;

/* VARIVEIS DO CURSOR C_CTREC */
DECLARE @V_CTREC_CDFILIAL     VARCHAR(4);
DECLARE @V_CTREC_NRLANCTONF   VARCHAR(10);
DECLARE @V_CTREC_CDEMPRESA    VARCHAR(2);
DECLARE @V_CTREC_CDFIMOVFLREC VARCHAR(4);
DECLARE @V_CTREC_CDCLASSFINA  VARCHAR(6);
DECLARE @V_CTREC_DTMOVFLUXO   DATETIME;
DECLARE @V_CTREC_IDMOVFLUXO   VARCHAR(1);
DECLARE @V_CTREC_VRTOTCTREC   FLOAT;

/* VARIVEIS DO CURSOR C_CTPAG */
DECLARE @V_CTPAG_CDFILIAL     VARCHAR(4);
DECLARE @V_CTPAG_NRLANCTONF   VARCHAR(10);
DECLARE @V_CTPAG_CDEMPRESA    VARCHAR(2);
DECLARE @V_CTPAG_CDFIMOVFLPAG VARCHAR(4);
DECLARE @V_CTPAG_CDCLASSFINA  VARCHAR(6);
DECLARE @V_CTPAG_DTMOVFLUXO   DATETIME;
DECLARE @V_CTPAG_IDMOVFLUXO   VARCHAR(1);
DECLARE @V_CTPAG_VRTOTCTPAG   FLOAT;

BEGIN
   DECLARE C_CTREC CURSOR FOR
   SELECT CR.CDFILIAL,    CR.NRLANCTONF,
          CR.CDEMPRESA,   CR.CDFIMOVFLREC,
          CR.CDCLASSFINA, CR.DTMOVFLUXO,
          CR.IDMOVFLUXO,  SUM(CR.VRATUAREC) VRTOTCTREC
   FROM CONTARECEBER CR,
        NOTAFISCAL   NF
   WHERE (CR.CDEMPRESA    IS NOT NULL) AND
         (CR.CDFIMOVFLREC IS NOT NULL) AND
         (CR.CDCLASSFINA  IS NOT NULL) AND
         (CR.DTMOVFLUXO   IS NOT NULL) AND
         (CR.IDMOVFLUXO   IS NOT NULL) AND
         (CR.IDMOVFLUXO = 'E')         AND
         (NF.IDSTATUS   = 'V')         AND
         (NF.CDFILIAL   = CR.CDFILIAL) AND
         (NF.NRLANCTONF = CR.NRLANCTONF)
   GROUP BY CR.CDFILIAL,    CR.NRLANCTONF,
            CR.CDEMPRESA,   CR.CDFIMOVFLREC,
            CR.CDCLASSFINA, CR.DTMOVFLUXO,
            CR.IDMOVFLUXO;

   OPEN C_CTREC;
   FETCH NEXT FROM C_CTREC INTO @V_CTREC_CDFILIAL,    @V_CTREC_NRLANCTONF,
                                @V_CTREC_CDEMPRESA,   @V_CTREC_CDFIMOVFLREC,
                                @V_CTREC_CDCLASSFINA, @V_CTREC_DTMOVFLUXO,
                                @V_CTREC_IDMOVFLUXO,  @V_CTREC_VRTOTCTREC;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_QTFLUXO = COUNT(*), @V_VRFLUXO = SUM(VRENTMFLUXO)
      FROM MOVFLUXO
      WHERE CDEMPRESA   = @V_CTREC_CDEMPRESA    AND
            CDFILIAL    = @V_CTREC_CDFIMOVFLREC AND
            CDCLASSFINA = @V_CTREC_CDCLASSFINA  AND
            DTMOVFLUXO  = @V_CTREC_DTMOVFLUXO   AND
            IDMOVFLUXO  = 'P';

      IF (@V_QTFLUXO = 0) BEGIN
         INSERT INTO MOVFLUXO
           (CDCLASSFINA,
            CDEMPRESA,
            CDFILIAL,
            DTMOVFLUXO,
            IDMOVFLUXO,
            VRENTMFLUXO,
            VRSAIMFLUXO)
         VALUES
           (@V_CTREC_CDCLASSFINA,
            @V_CTREC_CDEMPRESA,
            @V_CTREC_CDFIMOVFLREC,
            @V_CTREC_DTMOVFLUXO,
            'P',
            @V_CTREC_VRTOTCTREC,
            0);
      END
      ELSE BEGIN
         UPDATE MOVFLUXO
         SET VRENTMFLUXO = ROUND(@V_VRFLUXO + @V_CTREC_VRTOTCTREC, 2)
         WHERE CDCLASSFINA = @V_CTREC_CDCLASSFINA  AND
               CDEMPRESA   = @V_CTREC_CDEMPRESA    AND
               CDFILIAL    = @V_CTREC_CDFIMOVFLREC AND
               DTMOVFLUXO  = @V_CTREC_DTMOVFLUXO   AND
               IDMOVFLUXO  = 'P';
      END;

      UPDATE MOVFLUXO
      SET VRENTMFLUXO = ROUND(VRENTMFLUXO - @V_CTREC_VRTOTCTREC, 2)
      WHERE CDCLASSFINA = @V_CTREC_CDCLASSFINA  AND
            CDEMPRESA   = @V_CTREC_CDEMPRESA    AND
            CDFILIAL    = @V_CTREC_CDFIMOVFLREC AND
            DTMOVFLUXO  = @V_CTREC_DTMOVFLUXO   AND
            IDMOVFLUXO  = @V_CTREC_IDMOVFLUXO;

      UPDATE CONTARECEBER
      SET IDMOVFLUXO = 'P'
      WHERE CDCLASSFINA  = @V_CTREC_CDCLASSFINA  AND
            CDEMPRESA    = @V_CTREC_CDEMPRESA    AND
            CDFIMOVFLREC = @V_CTREC_CDFIMOVFLREC AND
            DTMOVFLUXO   = @V_CTREC_DTMOVFLUXO   AND
            IDMOVFLUXO   = @V_CTREC_IDMOVFLUXO   AND
            CDFILIAL     = @V_CTREC_CDFILIAL     AND
            NRLANCTONF   = @V_CTREC_NRLANCTONF;

      FETCH NEXT FROM C_CTREC INTO @V_CTREC_CDFILIAL,    @V_CTREC_NRLANCTONF,
                                   @V_CTREC_CDEMPRESA,   @V_CTREC_CDFIMOVFLREC,
                                   @V_CTREC_CDCLASSFINA, @V_CTREC_DTMOVFLUXO,
                                   @V_CTREC_IDMOVFLUXO,  @V_CTREC_VRTOTCTREC;
   END;
   CLOSE C_CTREC;
   DEALLOCATE C_CTREC;

   DECLARE C_CTPAG CURSOR FOR
   SELECT CP.CDFILIAL,    CP.NRLANCTONF,
          CP.CDEMPRESA,   CP.CDFIMOVFLPAG,
          CP.CDCLASSFINA, CP.DTMOVFLUXO,
          CP.IDMOVFLUXO,  SUM(CP.VRATUAPAG) VRTOTCTPAG
   FROM CONTAPAGAR CP,
        NOTAFISCAL NF
   WHERE (CP.CDEMPRESA    IS NOT NULL) AND
         (CP.CDFIMOVFLPAG IS NOT NULL) AND
         (CP.CDCLASSFINA  IS NOT NULL) AND
         (CP.DTMOVFLUXO   IS NOT NULL) AND
         (CP.IDMOVFLUXO   IS NOT NULL) AND
         (CP.IDMOVFLUXO = 'E')         AND
         (NF.IDSTATUS   = 'V')         AND
         (NF.CDFILIAL   = CP.CDFILIAL) AND
         (NF.NRLANCTONF = CP.NRLANCTONF)
   GROUP BY CP.CDFILIAL,    CP.NRLANCTONF,
            CP.CDEMPRESA,   CP.CDFIMOVFLPAG,
            CP.CDCLASSFINA, CP.DTMOVFLUXO,
            CP.IDMOVFLUXO;

   OPEN C_CTPAG;
   FETCH NEXT FROM C_CTPAG INTO @V_CTPAG_CDFILIAL,    @V_CTPAG_NRLANCTONF,
                                @V_CTPAG_CDEMPRESA,   @V_CTPAG_CDFIMOVFLPAG,
                                @V_CTPAG_CDCLASSFINA, @V_CTPAG_DTMOVFLUXO,
                                @V_CTPAG_IDMOVFLUXO,  @V_CTPAG_VRTOTCTPAG;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_QTFLUXO = COUNT(*), @V_VRFLUXO = SUM(VRSAIMFLUXO)
      FROM MOVFLUXO
      WHERE CDEMPRESA   = @V_CTPAG_CDEMPRESA    AND
            CDFILIAL    = @V_CTPAG_CDFIMOVFLPAG AND
            CDCLASSFINA = @V_CTPAG_CDCLASSFINA  AND
            DTMOVFLUXO  = @V_CTPAG_DTMOVFLUXO   AND
            IDMOVFLUXO  = 'P';

      IF (@V_QTFLUXO = 0) BEGIN
         INSERT INTO MOVFLUXO
           (CDCLASSFINA,
            CDEMPRESA,
            CDFILIAL,
            DTMOVFLUXO,
            IDMOVFLUXO,
            VRENTMFLUXO,
            VRSAIMFLUXO)
         VALUES
           (@V_CTPAG_CDCLASSFINA,
            @V_CTPAG_CDEMPRESA,
            @V_CTPAG_CDFIMOVFLPAG,
            @V_CTPAG_DTMOVFLUXO,
            'P',
            0,
            @V_CTPAG_VRTOTCTPAG);
      END
      ELSE BEGIN
         UPDATE MOVFLUXO
         SET VRSAIMFLUXO = ROUND(@V_VRFLUXO + @V_CTPAG_VRTOTCTPAG, 2)
         WHERE CDCLASSFINA = @V_CTPAG_CDCLASSFINA  AND
               CDEMPRESA   = @V_CTPAG_CDEMPRESA    AND
               CDFILIAL    = @V_CTPAG_CDFIMOVFLPAG AND
               DTMOVFLUXO  = @V_CTPAG_DTMOVFLUXO   AND
               IDMOVFLUXO  = 'P';
      END;

      UPDATE MOVFLUXO
      SET VRSAIMFLUXO = ROUND(VRSAIMFLUXO - @V_CTPAG_VRTOTCTPAG, 2)
      WHERE CDCLASSFINA = @V_CTPAG_CDCLASSFINA  AND
            CDEMPRESA   = @V_CTPAG_CDEMPRESA    AND
            CDFILIAL    = @V_CTPAG_CDFIMOVFLPAG AND
            DTMOVFLUXO  = @V_CTPAG_DTMOVFLUXO   AND
            IDMOVFLUXO  = @V_CTPAG_IDMOVFLUXO;

      UPDATE CONTAPAGAR
      SET IDMOVFLUXO = 'P'
      WHERE CDCLASSFINA  = @V_CTPAG_CDCLASSFINA  AND
            CDEMPRESA    = @V_CTPAG_CDEMPRESA    AND
            CDFIMOVFLPAG = @V_CTPAG_CDFIMOVFLPAG AND
            DTMOVFLUXO   = @V_CTPAG_DTMOVFLUXO   AND
            IDMOVFLUXO   = @V_CTPAG_IDMOVFLUXO   AND
            CDFILIAL     = @V_CTPAG_CDFILIAL     AND
            NRLANCTONF   = @V_CTPAG_NRLANCTONF;

      FETCH NEXT FROM C_CTPAG INTO @V_CTPAG_CDFILIAL,    @V_CTPAG_NRLANCTONF,
                                   @V_CTPAG_CDEMPRESA,   @V_CTPAG_CDFIMOVFLPAG,
                                   @V_CTPAG_CDCLASSFINA, @V_CTPAG_DTMOVFLUXO,
                                   @V_CTPAG_IDMOVFLUXO,  @V_CTPAG_VRTOTCTPAG;
   END;
   CLOSE C_CTPAG;
   DEALLOCATE C_CTPAG;
END;
GO
